#include "partition.h"
#include <bits/stdc++.h>
using namespace std;
std::vector<int> solve(std::vector<int> A)
{
    int n=A.size();
    vector<pair<int, int>>A2;
    map<int, int>freq;
    for(int i=0;i<n;i++)
    {
        A2.push_back({A[i], i});
        freq[A[i]]++;
    }
    sort(A2.begin(), A2.end());
    vector<int>V;
    for(int i=0;i<n;i++)
    {
        int x=freq[A2[i].first];
        freq[A2[i].first]=0;
        for(int j=i;j<i+x/2;j++)
        {
            V.push_back(A2[j].second);
            A2[j].first=-1;
        }
    }
    sort(A2.begin(), A2.end());
    for(int i=0;i<n;i++)
    {
        if(A2[i].first==-1)
        {
            continue;
        }
        else
        {
            V.push_back(A2[i].second);
        }
    }
    return {V};
}
